/****************************************************************/
/*																*/
/*				Bruch.h Version 1.3.5							*/
/*																*/
/*				Fachhochschule Jena - Informatik IIa			*/
/*				Projektarbeit Matrix							*/
/*				Set 2.08										*/
/*				Projektgruppe 1									*/
/*				Jrgen Dffinger  								*/
/*																*/
/****************************************************************/

/****************************************************************/
/*						Beschreibung:							*/
/*																*/
/*	Die Bruch.h enthlt die Deklarationen zu den Attributen und	*/
/*	Methoden der Klasse Bruch. Die klasse Bruch ermglicht es	*/
/*	Zahlen als Bruch zu behandeln. Dabei werden arithmetische	*/
/*	Operatoren und Vergleichs-operatoren zur Verfgung gestellt.*/
/*	Es werden nur Ganzzahlausdrcke fr Zhler und Nenner		*/
/*	verwendet werden, da der Zhler und Nenner vom DatenTyp		*/
/*	sind. Ein Krzungsalgorithmus wurde ebenfalls implementiert.*/
/*	Dieser kann nicht selber aufgerufen werden. Das Krzen		*/
/*	wird automatisch vorgenommen, sobald Werte des Bruchs		*/
/*	verndert werden.											*/
/*																*/
/****************************************************************/



using namespace std;



class Bruch
{

private:

	//	Typdefinition
	typedef long base_type;
	typedef Bruch my_type;



	//	Deklaration der Attribute
	base_type nenner;
	base_type zaehler;


	
	void init();								//	Initialisierung
	void setNenner(); 							//	Methode zur Bedingung Nenner nicht negativ
	base_type ggT(base_type a, base_type b);	// grter gemeinsamer Teiler (ggT)
	my_type kuerzen();							//	Bruch krzen



public:

	Bruch();												//	Konstruktor
	Bruch(base_type gz);									//	Konstruktor zur bernahme eines Ganzzahl ausdrucks.
	Bruch(base_type z, base_type n);						//	Konstruktor mit bergebenen Vorgabewerten
	Bruch::Bruch (const my_type& orig);						// Copy-Konstruktor
	~Bruch();												//	Destruktor
	friend istream& operator >>(istream &is, my_type &b);	//	Eingabe
	friend ostream& operator <<(ostream &os, my_type &b);	//	Ausgabe
	my_type operator + (const my_type& b) const;			//	Addition
	my_type& operator += (const my_type& b);				//	Addition mit Operator +=
	my_type operator - (const my_type& b) const;			//	Subtraktion
	my_type& operator -= (const my_type& b);				//	Subtraktion mit Operator +=
	my_type operator * (const my_type& b) const;			// Multiplikation
	my_type& operator *= (const my_type& b);				// Multiplikation mit Operator *=
	my_type operator / (const my_type& b) const;			//	Division 
	my_type& operator /= (my_type& b);						//	Division mit operator /=
	my_type operator - ();									// unres Minus
	bool operator < (const my_type& b) const;				//	kleiner als
	bool operator > (const my_type& b) const;				//	grer als
	bool operator <= (const my_type& b) const;				//	kleiner gleich
	bool operator >= (const my_type& b) const;				//	grer gleich
	bool operator == (const my_type& b) const;				//	gleich
	bool operator != (const my_type& b) const;				//	ungleich
	my_type operator = (my_type& b);					//	Zuweisungsoperator
};